/*
	File: context.dcl
	Project: CleanFloat
	Author: Shivkumar Chandrasekaran
	Email: shiv@ece.ucsb.edu
	Purpose: Contextual zippers
	See also: CamlFloat
	Date: 10.03.2003
	
	$Id$
*/

definition module context

import StdEnv

:: Context e
:: Option e = None | Some !e

cempty :: Context e
cget :: !(Context e) !Int -> (Option e, Context e)
cset :: !(Context e) !Int !(Option e) -> Context e
choose :: !(Context e) -> Option (Int, e)
first :: !(Context e) -> (Option (Int, e), Context e)
next :: !(Context e) -> (Option (Int, e), Context e)
kadesi :: !(Context e) -> (Option (Int, e), Context e)
prev :: !(Context e) -> (Option (Int, e), Context e)
toList :: !(Context e) -> [!(Int,e)!]